#!/usr/bin/python
# -*- coding:utf-8 -*-
#
#   Copyright 2008-2009 Le Coz Florent <louizatakk@fedoraproject.org>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the WTF Public License as published by
#   Sam Hocevar.
#
#   DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#   Version 2, December 2004
#   DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#   0. You just DO WHAT THE FUCK YOU WANT TO.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

import sys, os
import gtk
if os.name == 'nt':
    import pygtk, pango, atk
import cairo

class CardPic(gtk.DrawingArea):
    '''a card, DRAWN !!!!111'''

    def __init__(self, data=None):
        gtk.DrawingArea.__init__(self)
        self.size = 4
        self.set_size_request(63*self.size, 88*self.size)
        self.color = None
        self.info = None
        self.color_dict = {'B': ((0.1, 0.1, 0.1), (0.4, 0.4, 0.4)),
                           'U': ((0.2, 0.2, 0.9), (0.4, 0.4, 1)),
                           'R': ((1, 0.2, 0.2), (1, 0.4, 0.4)),
                           'G': ((0.1, 0.8, 0.1), (0.4, 1, 0.4)),
                           'W': ((1, 1, 1), (0.8, 0.8, 0.8)),
                           'Gld': ((0.9, 0.9, 0), (0.9, 0.9, 0.4)),
                           'Lnd': ((0.45, 0.4, 0.1), (0.55, 0.6, 0.5)),
                           'Art': ((0.5, 0.5, 0.5), (0.8, 0.8, 0.8))}
        self.connect('expose-event', self.area_expose)

    def area_expose(self, area, event=None):
        '''draw the card (and redraw it, when exposed)'''
        if self.info is None:
            return
        self.context = self.window.cairo_create()

        col = self.color_dict[self.color]
        # card
        self.context.set_source_rgb(col[0][0], col[0][1], col[0][2])
        self.context.rectangle(0,
                               0,
                               63* self.size,
                               88 * self.size)
        self.context.fill()
        # image zone
        self.context.set_source_rgb(0.2, 0.2, 0.2)
        self.context.rectangle(2 * self.size,
                               5 * self.size,
                               63 * self.size - 4 * self.size,
                               28 * self.size)
        self.context.fill()
        # text zone
        self.context.set_source_rgb(col[1][0], col[1][1], col[1][2])
        self.context.rectangle(2 * self.size,
                               28 * self.size + 10 * self.size,
                               63 * self.size - 4 * self.size,
                               63 * self.size - 18 * self.size)
        self.context.fill()
        # draw name
        #print self.color
        if self.color == 'B':
            self.context.set_source_rgb(0.9, 0.9, 0.9)
        else:
            self.context.set_source_rgb(0.1, 0.1, 0.1)
        self.context.move_to(3 * self.size, 4 * self.size)
        self.context.show_text(self.info[0])

        # draw type
        self.context.move_to(2 * self.size,  37 * self.size)
        self.context.show_text(self.info[4])
        # draw power
        if self.info[6] != 'None' or self.info[6] == '':
            self.context.move_to((59-len(self.info[6])) * self.size, 86 * self.size)
            self.context.show_text(self.info[6])
        # draw cost
        if self.info[3] != 'None':
            self.context.move_to((56 - len(self.info[3])) * self.size, 4 * self.size)
            self.context.show_text(self.info[3])
        # draw text
        text_li = self.text_to_list()
#        print text_li
        i = 0
        if len(text_li) >= 11:
            incr = 4
        else:
            incr = 3
        try:
            self.context.move_to(3 * self.size, 33 * self.size + 10 * self.size)
            for line in text_li:
                self.context.show_text(line)
                i += incr
                self.context.move_to(3 * self.size, (33 + i) * self.size + 10 * self.size)
        except cairo.Error:
            self.context.move_to(3 * self.size, (33 + i) * self.size + 10 * self.size)
            self.context.show_text('BUG')

    def text_to_list(self):
        max = 47
        li = (self.info[5]).split('@')
        new_list = []
        for elem in li:
            max -= elem.count('m')
            max -= elem.count('M')
            max -= elem.count('W')
            max -= elem.count('w')
            while len(elem) > max:
                new_list.append(elem[:find_last_space(elem, max)])
                elem = elem[find_last_space(elem, max)+1:]
            new_list.append(elem)
        return new_list

def find_last_space(str, max):
    pos = str.find(' ')
    while str.find(' ', pos+1) < max and str.find(' ', pos+1) != -1:
        pos = str.find(' ', pos+1)
    return pos


if __name__ == "__main__":
    window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    window.set_title("drawing test example")
    window.connect("destroy", gtk.mainquit)

    pic = CardPic('dunno')
    window.add(pic)
    window.show_all()

    gtk.main()


